<?php // v2.3

class block_grade_me extends block_base {
  
function init() {
    global $CFG;
    $this->title = get_string('title','block_grade_me');
    $this->version = 2010092800;
}

function array2str($array) {
    if (count($array) > 0) $string = implode(',',$array);
    else $string = NULL;
    return $string;
}

function get_content() {
    if ($this->content !== NULL) {
        return $this->content;
    }
    
    global $COURSE, $CFG, $USER, $SITE;
    
    // create the content class
    $this->content = new stdClass;
    $this->content->text = '';
    $this->content->footer = '';
    
    // setup arrays
    $c_arr = array();
    $assignment_grader = array();
    $quiz_grader = array();
    $allgroups = array();
    $separategroups = array();
    $assignment_grader_ng = array();
    $quiz_grader_ng = array();
    
    // get time format string
    $date_time_string = get_string('datetime','block_grade_me');
    
    // define excess
    $excess = false;
    // set counter
    $i = 0;
    
    if ($COURSE->id == 1) {
        $query = "SELECT id, groupmode, groupmodeforce FROM {$CFG->prefix}course";
        $cids = get_recordset_sql($query);
        $rs = get_recordset_sql($query);
        while ($cids = rs_fetch_next_record($rs)) {
            $context = get_context_instance(CONTEXT_COURSE,$cids->id);
            if (has_capability('mod/assignment:grade',$context)) $assignment_grader[] = $cids->id;
            if (has_capability('mod/quiz:grade',$context)) $quiz_grader[] = $cids->id;
            if (has_capability('moodle/site:accessallgroups',$context)) $allgroups[] = $cids->id;
            elseif ($cids->groupmode == 1  &&  $cids->groupmodeforce == 1) $separategroups[] = $cids->id;
        }
    }
    else {
        // get the current context
        $context = get_context_instance(CONTEXT_COURSE,$COURSE->id);
        if (has_capability('mod/assignment:grade',$context)) $assignment_grader[] = $COURSE->id;
        if (has_capability('mod/quiz:grade',$context)) $quiz_grader[] = $COURSE->id;
        if (has_capability('moodle/site:accessallgroups',$context)) $allgroups[] = $COURSE->id;
        elseif ($COURSE->groupmode == 1  &&  $COURSE->groupmodeforce == 1) $separategroups[] = $COURSE->id;
    }
    
    // create new arrays for instances that don't need to respect groups
    if (count($assignment_grader) > 0) $assignment_grader_ng = array_diff($assignment_grader,$separategroups);
    if (count($quiz_grader) > 0) $quiz_grader_ng = array_diff($quiz_grader,$separategroups);
    // convert arrays to comma-delimited strings
    $assignment_grader_ng = $this->array2str($assignment_grader_ng);
    $quiz_grader_ng = $this->array2str($quiz_grader_ng);
    $assignment_grader = $this->array2str($assignment_grader);
    $quiz_grader = $this->array2str($quiz_grader);
    $allgroups = $this->array2str($allgroups);
    $separategroups = $this->array2str($separategroups);
    
    // get groups for forced separate courses
    if (isset($separategroups)  &&  (isset($assignment_grader)  ||  isset($quiz_grader))) {
        $groups = array();
        $query = "SELECT g.id id 
                    FROM {$CFG->prefix}course c 
                       , {$CFG->prefix}groups g 
                       , {$CFG->prefix}groups_members g_m 
                   WHERE c.id = g.courseid 
                     AND g.id = g_m.groupid 
                     AND g_m.userid = {$USER->id}
                     AND c.id IN ({$separategroups})";
        $rs = get_recordset_sql($query);
        while ($gids = rs_fetch_next_record($rs)) $groups[] = $gids->id;
        $groups = $this->array2str($groups);
    }
    
    // check if user has permission to grade assignments
    if (isset($assignment_grader_ng)) {
        $query = "SELECT c.id course_id 
                       , c.shortname course_name 
                       , a.id as a_id 
                       , a.name as a_name 
                       , a_s.id as sub_id 
                       , c_m.id module_id 
                       , u.id as user_id 
                       , u.lastname as last_name 
                       , u.firstname as first_name 
                       , a_s.timemodified time_submitted 
                    FROM {$CFG->prefix}assignment_submissions a_s 
              INNER JOIN {$CFG->prefix}assignment a 
                      ON (a.id = a_s.assignment)
              INNER JOIN {$CFG->prefix}user u 
                      ON (u.id = a_s.userid)
              INNER JOIN {$CFG->prefix}course c 
                      ON (a.course = c.id)
               LEFT JOIN {$CFG->prefix}course_modules c_m 
                      ON (c_m.instance = a.id AND c_m.module IN (SELECT m.id FROM {$CFG->prefix}modules m WHERE m.name='assignment')) 
              INNER JOIN {$CFG->prefix}role_assignments ra 
                      ON (ra.userid = u.id) 
              INNER JOIN {$CFG->prefix}context cx 
                      ON (ra.contextid = cx.id AND cx.instanceid = c.id) 
                   WHERE a_s.timemodified > a_s.timemarked 
                     AND c.id IN ({$assignment_grader_ng}) 
                     AND cx.contextlevel = 50 
                     AND ra.roleid IN ({$CFG->gradebookroles}) 
                ORDER BY course_name
                       , a_name
                       , last_name
                       , first_name
                       , a_s.timemodified
                   LIMIT 250
                         ";
        $rs = get_recordset_sql($query);
        if ($rs->RecordCount() == 250) $excess = true;
        while ($a = rs_fetch_next_record($rs)) {
            $c_arr[$a->course_name][$a->course_id][$a->a_name.'|assignment='.$a->a_id][$a->module_id][$i] = serialize(array('a_id' => $a->a_id, 'module_id' => $a->module_id, 'sub_id' => $a->sub_id, 'user_id' => $a->user_id, 'last_name' => $a->last_name, 'first_name' => $a->first_name, 'time_submitted' => $a->time_submitted));
            $i++;
        }
    }
    
    if (isset($assignment_grader)  &&  isset($groups)) {
        $query = "SELECT c.id course_id 
                       , c.shortname course_name 
                       , a.id as a_id 
                       , a.name as a_name 
                       , a_s.id as sub_id 
                       , c_m.id module_id 
                       , u.id as user_id 
                       , u.lastname as last_name 
                       , u.firstname as first_name 
                       , a_s.timemodified time_submitted 
                    FROM {$CFG->prefix}assignment_submissions a_s 
              INNER JOIN {$CFG->prefix}assignment a 
                      ON (a.id = a_s.assignment)
              INNER JOIN {$CFG->prefix}user u 
                      ON (u.id = a_s.userid)
              INNER JOIN {$CFG->prefix}course c 
                      ON (a.course = c.id)
               LEFT JOIN {$CFG->prefix}groups g 
                      ON (c.id = g.courseid AND g.id IN ({$groups})) 
               LEFT JOIN {$CFG->prefix}course_modules c_m 
                      ON (c_m.instance = a.id AND c_m.module IN (SELECT m.id FROM {$CFG->prefix}modules m WHERE m.name='assignment')) 
              INNER JOIN {$CFG->prefix}role_assignments ra 
                      ON (ra.userid = u.id) 
              INNER JOIN {$CFG->prefix}context cx 
                      ON (ra.contextid = cx.id AND cx.instanceid = c.id) 
                   WHERE a_s.timemodified > a_s.timemarked 
                     AND c.id IN ({$assignment_grader}) 
                     AND cx.contextlevel = 50 
                     AND ra.roleid IN ({$CFG->gradebookroles}) 
                     AND (g.id IN (SELECT {$CFG->prefix}groups.id 
                                     FROM {$CFG->prefix}groups 
                                        , {$CFG->prefix}groups_members 
                                    WHERE {$CFG->prefix}groups.id = {$CFG->prefix}groups_members.groupid 
                                      AND {$CFG->prefix}groups_members.userid = u.id 
                                      AND {$CFG->prefix}groups.id IN ({$groups}) 
                                  ) 
                               OR g.id IS NULL)
                ORDER BY course_name
                       , a_name
                       , last_name
                       , first_name
                       , a_s.timemodified
                   LIMIT 250
                         ";
        $rs = get_recordset_sql($query);
        if ($rs->RecordCount() == 250) $excess = true;
        while ($a = rs_fetch_next_record($rs)) {
            $c_arr[$a->course_name][$a->course_id][$a->a_name.'|assignment='.$a->a_id][$a->module_id][$i] = serialize(array('a_id' => $a->a_id, 'module_id' => $a->module_id, 'sub_id' => $a->sub_id, 'user_id' => $a->user_id, 'last_name' => $a->last_name, 'first_name' => $a->first_name, 'time_submitted' => $a->time_submitted));
            $i++;
        }
    }
    
    // check if user has permission to grade quizzes
    if (isset($quiz_grader_ng)) {
        $st_ids = array();
        $st_timestamps = array();
        $query = "SELECT MAX(q_s.id) state_id  
                       , MAX(q_s.timestamp) timestamp 
                    FROM {$CFG->prefix}question_states q_s 
                       , (SELECT id FROM {$CFG->prefix}question WHERE qtype IN ('essay','fileresponse')) qu
                   WHERE qu.id = q_s.question 
                GROUP BY q_s.question 
                       , q_s.attempt 
            ";
        $rs = get_recordset_sql($query);
        while ($states = rs_fetch_next_record($rs)) {
            $st_ids[] = $states->state_id;
            $st_timestamps[] = $states->timestamp;
        }
        if ($rs->RecordCount() > 0) {
            $st_ids = implode(',',$st_ids);
            $st_timestamps = implode(',',$st_timestamps);
            
            $query = "SELECT c.id course_id
                           , c.shortname course_name
                           , qu_st.id state_id 
                           , q.id q_id
                           , q.name q_name
                           , c_m.id module_id 
                           , qu.id question_id
                           , qu.name question_name
                           , qu.qtype question_icon
                           , u.id user_id
                           , u.lastname last_name
                           , u.firstname first_name
                           , q_a.timefinish time_submitted
                        FROM {$CFG->prefix}question qu 
                  INNER JOIN {$CFG->prefix}question_states qu_st 
                          ON (qu.id = qu_st.question AND qu_st.grade = 0 AND qu_st.raw_grade = 0) 
                  INNER JOIN {$CFG->prefix}quiz_attempts q_a 
                          ON (qu_st.attempt = q_a.id) 
                  INNER JOIN {$CFG->prefix}quiz q 
                          ON (q.id = q_a.quiz) 
                  INNER JOIN {$CFG->prefix}user u 
                          ON (q_a.userid = u.id) 
                  INNER JOIN {$CFG->prefix}course c 
                          ON (c.id = q.course) 
                   LEFT JOIN {$CFG->prefix}course_modules c_m 
                          ON (c_m.instance = q.id AND c_m.module IN (SELECT m.id FROM {$CFG->prefix}modules m WHERE m.name='quiz')) 
                  INNER JOIN {$CFG->prefix}role_assignments ra 
                          ON (ra.userid = u.id) 
                  INNER JOIN {$CFG->prefix}context cx 
                          ON (ra.contextid = cx.id AND cx.instanceid = c.id) 
                       WHERE qu.qtype IN ('essay','fileresponse')
                         AND q_a.timefinish > 0
                         AND qu_st.timestamp = q_a.timefinish
                         AND qu_st.id IN ({$st_ids}) 
                         AND qu_st.timestamp IN ({$st_timestamps}) 
                         AND c.id IN ({$quiz_grader_ng}) 
                         AND cx.contextlevel = 50 
                         AND ra.roleid IN ({$CFG->gradebookroles}) 
                    ORDER BY course_name
                           , q_name
                           , question_id
                           , last_name
                           , first_name
                           , q_a.timefinish
                       LIMIT 250
                             ";
            $rs = get_recordset_sql($query);
            if ($rs->RecordCount() == 250) $excess = true;
            while ($q = rs_fetch_next_record($rs)) {
                $c_arr[$q->course_name][$q->course_id][$q->q_name.'|quiz='.$q->q_id][$q->module_id][$i] = serialize(array('q_id' => $q->q_id, 'module_id' => $q->module_id, 'question_id' => $q->question_id, 'question_name' => $q->question_name, 'question_icon' => $q->question_icon, 'user_id' => $q->user_id, 'last_name' => $q->last_name, 'first_name' => $q->first_name, 'time_submitted' => $q->time_submitted));
                $i++;
            }
        }
    }
        
    if (isset($quiz_grader)  &&  isset($groups)) {
        $st_ids = array();
        $st_timestamps = array();
        $query = "SELECT MAX(q_s.id) state_id  
                       , MAX(q_s.timestamp) timestamp 
                    FROM {$CFG->prefix}question_states q_s 
                       , (SELECT id FROM {$CFG->prefix}question WHERE qtype IN ('essay','fileresponse')) qu
                   WHERE qu.id = q_s.question 
                GROUP BY q_s.question 
                       , q_s.attempt 
            ";
        $rs = get_recordset_sql($query);
        while ($states = rs_fetch_next_record($rs)) {
            $st_ids[] = $states->state_id;
            $st_timestamps[] = $states->timestamp;
        }
        if ($rs->RecordCount() > 0) {
            $st_ids = implode(',',$st_ids);
            $st_timestamps = implode(',',$st_timestamps);
            
            $query = "SELECT c.id course_id
                           , c.shortname course_name
                           , qu_st.id state_id 
                           , q.id q_id
                           , q.name q_name
                           , c_m.id module_id 
                           , qu.id question_id
                           , qu.name question_name
                           , qu.qtype question_icon
                           , u.id user_id
                           , u.lastname last_name
                           , u.firstname first_name
                           , q_a.timefinish time_submitted
                        FROM {$CFG->prefix}question qu 
                  INNER JOIN {$CFG->prefix}question_states qu_st 
                          ON (qu.id = qu_st.question AND qu_st.grade = 0 AND qu_st.raw_grade = 0) 
                  INNER JOIN {$CFG->prefix}quiz_attempts q_a 
                          ON (qu_st.attempt = q_a.id) 
                  INNER JOIN {$CFG->prefix}quiz q 
                          ON (q.id = q_a.quiz) 
                  INNER JOIN {$CFG->prefix}user u 
                          ON (q_a.userid = u.id) 
                  INNER JOIN {$CFG->prefix}course c 
                          ON (c.id = q.course) 
                   LEFT JOIN {$CFG->prefix}groups g 
                          ON (c.id = g.courseid AND g.id IN ({$groups})) 
                   LEFT JOIN {$CFG->prefix}course_modules c_m 
                          ON (c_m.instance = q.id AND c_m.module IN (SELECT m.id FROM {$CFG->prefix}modules m WHERE m.name='quiz')) 
                  INNER JOIN {$CFG->prefix}role_assignments ra 
                          ON (ra.userid = u.id) 
                  INNER JOIN {$CFG->prefix}context cx 
                          ON (ra.contextid = cx.id AND cx.instanceid = c.id) 
                       WHERE qu.qtype IN ('essay','fileresponse')
                         AND q_a.timefinish > 0
                         AND qu_st.timestamp = q_a.timefinish
                         AND qu_st.id IN ({$st_ids}) 
                         AND qu_st.timestamp IN ({$st_timestamps}) 
                         AND c.id IN ({$quiz_grader}) 
                         AND cx.contextlevel = 50 
                         AND ra.roleid IN ({$CFG->gradebookroles}) 
                         AND (g.id IN (SELECT {$CFG->prefix}groups.id 
                                         FROM {$CFG->prefix}groups 
                                            , {$CFG->prefix}groups_members 
                                        WHERE {$CFG->prefix}groups.id = {$CFG->prefix}groups_members.groupid 
                                          AND {$CFG->prefix}groups_members.userid = u.id 
                                          AND {$CFG->prefix}groups.id IN ({$groups}) 
                                      ) 
                                   OR g.id IS NULL)
                    ORDER BY course_name
                           , q_name
                           , question_id
                           , last_name
                           , first_name
                           , q_a.timefinish
                       LIMIT 250
                             ";
            $rs = get_recordset_sql($query);
            if ($rs->RecordCount() == 250) $excess = true;
            while ($q = rs_fetch_next_record($rs)) {
                $c_arr[$q->course_name][$q->course_id][$q->q_name.'|quiz='.$q->q_id][$q->module_id][$i] = serialize(array('q_id' => $q->q_id, 'module_id' => $q->module_id, 'question_id' => $q->question_id, 'question_name' => $q->question_name, 'question_icon' => $q->question_icon, 'user_id' => $q->user_id, 'last_name' => $q->last_name, 'first_name' => $q->first_name, 'time_submitted' => $q->time_submitted));
                $i++;
            }
        }
    }
    
    if (isset($assignment_grader)  ||  isset($quiz_grader)) {
        if ($excess) $this->content->text .= '<div class="excess">'.get_string('excess','block_grade_me').'</div>'."\r";
        // get image path
        $gradeImg = $CFG->wwwroot.'/blocks/grade_me/pix/check_mark.png';
        // Sort by course_name
        ksort($c_arr);
        // Traverse courses
        foreach ($c_arr AS $course_name => $v1) {
            $this->content->text .= '<dl>'."\r";
            // Traverse course ids
            foreach ($v1 AS $course_id => $v2) {
                // Sort by module name
                ksort($v2);
                // Add course link
                $this->content->text .= '<dt class="cmod"><a href="'.$CFG->wwwroot.'/grade/report/index.php?id='.$course_id.'" title="'.get_string('link_gradebook_icon','block_grade_me',$course_name).'"><img src="'.$CFG->pixpath.'/i/grades.gif" class="gm_icon" alt="'.get_string('alt_gradebook','block_grade_me').'" /></a> <a href="'.$CFG->wwwroot.'/course/view.php?id='.$course_id.'" title="'.get_string('link_gradebook','block_grade_me',$course_name).'">'.$course_name.'</a></dt>'."\r";
                // Traverse module names
                foreach ($v2 AS $mod_info => $v3) {
                    // Get module name
                    $mod_explode = explode('|',$mod_info,-1);
                    $mod_name = $mod_explode[0];
                    unset($mod_explode);
                    // Get module type
                    $mod_type = preg_replace('/=\d+/','',str_replace($mod_name.'|','',$mod_info));
                    if ($mod_type == 'assignment') $link = '/mod/'.$mod_type.'/submissions.php?id='.key($v3);
                    elseif ($mod_type == 'quiz') $link = '/mod/'.$mod_type.'/report.php?id='.key($v3);
                    $modlink = '/mod/'.$mod_type.'/view.php?id='.key($v3);
                    // Traverse module ids
                    foreach ($v3 AS $module_id => $v4) {
                        $this->content->text .= '<dd class="module">'."\r";  //open module
                        $module_img = ($link) ? '<a href="'.$CFG->wwwroot.$link.'" title="'.get_string('link_mod_img','block_grade_me',$mod_name).'"><img src="'.$CFG->modpixpath.'/'.$mod_type.'/icon.gif" alt="'.$mod_type.'" class="gm_icon" /></a>' : '<img src="'.$CFG->modpixpath.'/'.$mod_type.'/icon.gif" alt="'.$mod_type.'" class="gm_icon" />';
                        if ($link) $this->content->text .= '<div class="closed toggle" id="cmid'.$module_id.'" onclick="toggleClass(this.id,\'open\',\'closed\');toggleClass(this.id+\'div\',\'hide\',\'show\');"></div>'."\r";
                        unset($link);
                        $this->content->text .= $module_img.'<a href="'.$CFG->wwwroot.$modlink.'" title="'.get_string('link_mod','block_grade_me',$mod_name).'">'.$mod_name.'</a> ('.count($v4).')'."\r";
                        $this->content->text .= '<ul id="cmid'.$module_id.'div" class="hide cloakable">'."\r";
                        foreach ($v4 AS $k5 => $v5) {
                            $array = unserialize($v5);  // turn into an array
                            // output list item
                            $this->content->text .= '<li class="gradable">';  // open gradable
                            if ($mod_type == 'assignment') $submission_link = '/mod/assignment/submissions.php?id='.$array['module_id'].'&amp;userid='.$array['user_id'].'&amp;mode=single&amp;offset=1" target="_blank" onclick="this.target=\'grade'.$array['user_id'].'; return openpopup(\''.$CFG->wwwroot.'/mod/assignment/submissions.php?id='.$array['module_id'].'&amp;userid='.$array['user_id'].'&amp;mode=single&amp;offset=1\', \'grade'.$array['user_id'].'\', \'menubar=0,location=0,scrollbars,resizable,width=780,height=600\', 0);';
                            elseif ($mod_type == 'quiz') $submission_link = '/mod/quiz/report.php?q='.$array['q_id'].'&amp;mode=grading';
                            $this->content->text .= '<a href="'.$CFG->wwwroot.$submission_link.'" title="'.get_string('link_grade_img','block_grade_me').'"><img src="'.$gradeImg.'" class="gm_icon" alt="'.get_string('alt_mark','block_grade_me').'" /></a>';  // grade icon
                            unset($submission_link);  // we don't need this anymore
                            $this->content->text .= '<a href="'.$CFG->wwwroot.'/user/view.php?id='.$array['user_id'].'&amp;course='.$course_id.'" title="'.get_string('link_user_profile','block_grade_me',$array["first_name"]).'">'.$array['first_name'].' '.$array['last_name'].'</a>';  // user name and profile link
                            $this->content->text .= '<br />'.userdate($array['time_submitted'],$date_time_string);  // output submission date
                            $this->content->text .= '</li>';  // end gradable
                            $this->content->text .= "\r";
                        }
                        $this->content->text .= '  </ul>'."\r";
                        $this->content->text .= '</dd>'."\r";  // close module 
                    }
                }
            }
            $this->content->text .= '</dl>'."\r";
        }
        
        if (!$this->content->text  &&  isset($assignment_grader)  &&  isset($quiz_grader)) {
            $this->content->text .= '<div class="empty"><img src="'.$CFG->pixpath.'/s/smiley.gif" alt="'.get_string('alt_smiley','block_grade_me').'" /> '.get_string('nothing','block_grade_me').'</div>'."\r";
        }
        
        $this->content->text .= '';
    }
    
    return $this->content;
}
}

?>